function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import reduce from './../reduce';

/**
 * Concatenates N Arrays together.
 * @signature concat :: [a] -> [b] -> ...[n] -> [m]
 * @func
 * @example
 * concatN([1, 2], [3, 4], [5, 6]) // [1, 2, 3, 4, 5, 6]
 */
var concatN = function concatN() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return reduce([], function (acc, val) {
    return [].concat(_toConsumableArray(acc), _toConsumableArray(val));
  }, args);
};

export default concatN;