function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import curry from './../curry';
import isArray from './../util/isArray';

/**
 * Returns the difference between two arrays.
 * @signature difference :: [a] -> [b] -> [c]
 * @func
 * @example
 * difference([ 1, 2, 3 ], [ 1, 2, 4 ]) // [3]
 * difference([], [ 1, 2, 4 ]) // [ 1, 2, 4 ]
 * difference([ 1, 2, 3 ], []) // [ 1, 2, 3 ]
 * difference([ 1, 2, 3 ], null) // [ 1, 2, 3 ]
 */
var difference = /*#__PURE__*/curry(function (a, b) {
  var s = isArray(b) && b.length ? new Set(b) : new Set();

  return isArray(a) && a.length ? a.filter(function (x) {
    return !s.has(x);
  }) : [].concat(_toConsumableArray(s));
});

export default difference;