function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import curry from './../curry';
import isArray from './../util/isArray';

// Returns the symmetric difference between two arrays.
//
// symmetricDifference([ 1, 2, 3 ], [ 1, 2, 4 ]);
// >> [ 3, 4 ]
//
export default /*#__PURE__*/curry(function (a, b) {
  var sA = isArray(a) ? new Set(a) : new Set();
  var sB = isArray(b) ? new Set(b) : new Set();

  return [].concat(_toConsumableArray(a.filter(function (x) {
    return !sB.has(x);
  })), _toConsumableArray(b.filter(function (x) {
    return !sA.has(x);
  })));
});